#ifdef STRINGS_H
#error Double include
#endif

#ifdef GETSTRING
    #undef   GETSTRING
    #include "Strings.h"

    char *StrTable [MAXSTRING];

    #define STRING(a,b)  i = Str_##a; StrTable[i] = b;
    #define SETLIMIT(a) 
    void CPieterApp::InitStrTable (void) {
        unsigned i = 0;

#else
    #define STRINGS_H
    #define STRING(a,b)   Str_##a,
    #define SETLIMIT(a)   a
    extern void InitStrTable (void);
    extern char *StrTable [];
    enum StrTableTag {
#endif

    STRING (ErrParse, "Script error (line %3.3d): %s\n")
    STRING (S_Main,   "--Main--\n")
    STRING (S_AddVar, "Added var : %s [%x]\n")
    STRING (S_KillVar,"Killed var: %s [%x]\n")
    STRING (S_SetVar, "Var %s was %d, now %d\n")
    STRING (S_TNew,   "> Unknown %s\n")
    STRING (S_TFunc,  "> Function %s\n")
    STRING (S_TVar,   "> Variable %s\n")
    STRING (S_Token,  "> %s\n")
    STRING (S_None,   "No errors found.")
    STRING (S_ArBound,"Array bounds must be in range 2...4096.")
    STRING (S_Array,  "Array index missing [].")
    STRING (S_ArrayOv,"Array index is out of bounds.")
    STRING (S_Break,  "Break is only legal in 'while', 'do', 'for' or 'switch' loop.")
    STRING (S_Case,   "Case and Default are only legal in a 'switch' statement.")
    STRING (S_Cmd,    "Illegal command.")
    STRING (S_Cont,   "Continue is only legal in 'while', 'do' or 'for' loop.")
    STRING (S_DupDef, "This keyword is already defined.")
    STRING (S_EOF,    "End of script reached; one or more '}' missing.")
    STRING (S_Expr,   "Illegal expression (use any variable or constant, or (), !, -).")
    STRING (S_ForParn,"For statement requires parentheses ().")
    STRING (S_Func,   "Local function definitions are illegal.")
    STRING (S_FuncCl, "Function call requires parentheses.")
    STRING (S_FuncDef,"Require parentheses for parameters, or brackets for function body.")
    STRING (S_FuncNst,"Nested function calls are illegal.")
    STRING (S_FuncPrM,"Too many function parameters specified.")
    STRING (S_FuncPrF,"Too few function parameters specified.")
    STRING (S_LongID, "Identifier is too long (maximum of 32 characters).")
    STRING (S_NoEOF,  "Script may not continue after main function.")
    STRING (S_NoMain, "No main function found.")
    STRING (S_Ovflow, "Numerical constant is too large (maximum is 65535).")
    STRING (S_ParmOv, "Too many function parameters (maximum of 16).")
    STRING (S_ReqAsg, "Variable needs an assignment operator (=, &=, ++ etc).")
    STRING (S_RgtBrac,"Mismatched brackets {}.")
    STRING (S_RgtBrck,"Mismatched array indices [].")
    STRING (S_RgtParn,"Mismatched parentheses ().")
    STRING (S_Start,  "Only variable and function declarations are legal before main loop.")
    STRING (S_SwBrac, "Switch statement requires brackets {}.")
    STRING (S_SwNest, "Switch statements may not be nested.")
    STRING (S_Unknown,"Undefined symbol.")
    STRING (S_VarCmd, "Only mathematical statements and function calls are legal here.")
    STRING (S_VarFunc,"Variable is already defined as a function.")
    STRING (S_While,  "While required at the end of 'do' loop.")
    STRING (S_Fail,   "-*-")
    STRING (ErrLast,  "Aborted.")

    STRING (W_First,  " ")
    STRING (W_And1,   "and")
    STRING (W_Begin,  "begin")
    STRING (W_Break,  "break")
    STRING (W_Case,   "case")
    STRING (W_Cont,   "continue")
    STRING (W_Default,"default")
    STRING (W_Div1,   "div")
    STRING (W_Do,     "do")
    STRING (W_Else,   "else")
    STRING (W_End,    "end")
    STRING (W_Endl,   "endl")
    STRING (W_For,    "for")
    STRING (W_Func,   "function")
    STRING (W_Func1,  "func")
    STRING (W_If,     "if")
    STRING (W_Main,   "main")
    STRING (W_Mod1,   "mod")
    STRING (W_Not1,   "not")
    STRING (W_Or1,    "or")
    STRING (W_Print,  "print")
    STRING (W_Return, "return")
    STRING (W_Switch, "switch")
    STRING (W_Var,    "int")
    STRING (W_Var1,   "var")
    STRING (W_While,  "while")
    STRING (W_Xor1,   "xor")
    STRING (W_Const,  "[num]")
    STRING (W_False,  "false")
    STRING (W_True,   "true")
    STRING (W_Random, "random")
    STRING (W_Nop,    ";")
    STRING (W_Print1, "?")
    STRING (W_ParenL, "(")
    STRING (W_ParenR, ")")
    STRING (W_BrackL, "{")
    STRING (W_BrackR, "}")
    STRING (W_ArrayL, "[")
    STRING (W_ArrayR, "]")
    STRING (W_Comma,  ",")
    STRING (W_Comment,"/" "/")
    STRING (W_Comm1,  "#")
    STRING (W_ComLong,"/" "*")
    STRING (W_Equals1,"==")
    STRING (W_InEq1,  "=!")
    STRING (W_InEq2,  "<>")
    STRING (W_InEq3,  "><")
    STRING (W_GrEq1,  "=>")
    STRING (W_LsEq1,  "=<")
    STRING (W_Assign, "=")
    STRING (W_AsgAdd, "+=")
    STRING (W_AsgSub, "-=")
    STRING (W_AsgMult,"*=")
    STRING (W_AsgDiv, "/=")
    STRING (W_AsgMod, "%=")
    STRING (W_AsgAnd, "&=")
    STRING (W_AsgOr,  "|=")
    STRING (W_AsgXor, "^=")
    STRING (W_AsgLSh, "<<=")
    STRING (W_AsgRSh, ">>=")
    STRING (W_Inc,    "++")
    STRING (W_Dec,    "--")
    STRING (W_LogAnd, "&&")
    STRING (W_LogOr,  "||")
    STRING (W_Equals, "==")
    STRING (W_InEqual,"!=")
    STRING (W_GreatEq,">=")
    STRING (W_Greater,">")
    STRING (W_LessEq, "<=")
    STRING (W_Less,   "<")
    STRING (W_Power,  "**")
    STRING (W_Add,    "+")
    STRING (W_Minus,  "-")
    STRING (W_Modulo, "%")
    STRING (W_Divide, "/")
    STRING (W_Mult,   "*")
    STRING (W_And,    "&")
    STRING (W_Xor2,   "^^")
    STRING (W_Xor,    "^")
    STRING (W_Or,     "|")
    STRING (W_LShift, "<<")
    STRING (W_RShift, ">>")
    STRING (W_Not,    "!")
    STRING (W_Negate, "-")
    STRING (W_Quote,  "\"")
    STRING (W_Last,   "[eof]")
    STRING (SysLast,  "[sysfunc]")

    SETLIMIT (MAXSTRING)
};

#undef STRING
#undef SETLIMIT
